#ifndef SERIAL_CTRL_H
#define SERIAL_CTRL_H

/*!
  \file
  \brief VAڑ

  \author Satofumi KAMIMURA

  $Id$
*/

#include "ConnectionInterface.h"
#include <memory>
#include <string>


namespace beego {
  /*!
    \brief VAʐMnh
  */
  class SerialCtrl : public ConnectionInterface {
    SerialCtrl(const SerialCtrl& rhs);
    SerialCtrl& operator = (const SerialCtrl& rhs);

    struct pImpl;
    const std::auto_ptr<pImpl> pimpl;

  public:
    enum { NoTimeout = -1 };

    SerialCtrl(void);
    ~SerialCtrl(void);

    const char* what(void);
    bool connect(const char* device, long baudrate);
    void disconnect(void);
    bool isConnected(void);
    bool changeBaudrate(long baudrate);
    int send(const char* data, int size);
    int recv(char* data, int size, int timeout);
    int getLine(std::string& data, int timeout);
    int size(int timeout = 0);
    void clear(void);
    void skip(int timeout = NoTimeout);
    void flush(void);
  };
};

#endif /* !SERIAL_CTRL_H */
